Hooks:RegisterHook("OnCommanderInit")
Commander=Commander or {}
Commander._path = ModPath
Commander._data_path = ModPath.."save/options.txt"
Commander._data=Commander._data or {}
Commander._termmode=false
local function dostring(str)
	if str==nil then return "Not a statement" end
	local func, err=loadstring(str)
	if not func then return "ERROR: "..tostring(err) end
	local valid, rval=pcall(func)
	if valid then return rval else return "SCRIPT ERROR" end
end

Commander.commands=Commander.commands or {}
Commander.commands["do"]=function(arg1)
	if arg1 then
		return dostring(arg1)
	else return "Usage: //do <lua code block>"
	end
end

function Commander:Save()
	local file = io.open( self._data_path, "w+" )
	if file then
		file:write( json.encode( self._data ) )
		file:close()
	end
end
function Commander:Load()
	local file = io.open( self._data_path, "r" )
	if file then
		self._data = json.decode( file:read("*all") )
		file:close()
	end
end

function Commander:LoadCommand(name,path)
	if not name then log("[COMMANDER] No name specified") return nil end
	if not path then log("[COMMANDER] No path specified for "..tostring(name)) return nil end
	local f = io.open(path, "r")
	local fstr=f:read("*all")
	if f then
		log("[COMMANDER] Registering command \""..name.."\"")
		local fnc,err=loadstring(fstr)
		if not fnc then
			log(tostring(err))
			Commander.commands[name]=function(...) Commander:write("Script Error: "..tostring(err)) end
			return nil
		end
		local _oldlog=log
		local cgm = Commander.write
		Commander.write=function() end
		log=function() end
		local status,err=pcall(fnc)
		log=_oldlog
		Commander.write=cgm
		if not status then
			log(tostring(err))
			Commander.commands[name]=function(...) Commander:write("Script Error: "..tostring(err)) end
		else
			Commander.commands[name]=fnc
		end
	end
end
function Commander:Register(name,fnc)
	if not name then log("[COMMANDER] No name specified") return nil end
	if not fnc then log("[COMMANDER] No function specified for "..tostring(name)) return nil end
	if true then
		log("[COMMANDER] Registering command \""..name.."\"")
		local _oldlog=log
		local cgm = Commander.write
		Commander.write=function() end
		log=function() end
		local status,err=pcall(fnc)
		log=_oldlog
		Commander.write=cgm
		if not status then
			log(tostring(err))
			Commander.commands[name]=function(...) Commander:write("Script Error: "..tostring(err)) end
		else
			Commander.commands[name]=fnc
		end
	end
end
function Commander:write(message)
		if managers and managers.chat and managers.chat._receivers and managers.chat._receivers[1] then
		for _,rcv in pairs( managers.chat._receivers[1] ) do
			rcv:receive_message("", message, Color.yellow) -- "" equals the skull ingame
		end
		else
			log(tostring(message))
	end
end

local function isInGame()
	if not game_state_machine then
		return false
	end
	return string.find( game_state_machine:current_state_name(), "ingame" )
end

Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_Commander", function(menu_manager)
	MenuCallbackHandler.commander_save = function(self, item)
		--Commander:Save()
	end
	Commander.kbshow_termchat = function(self)
		if isInGame() then
			Commander:show_termchat()
		end
	end
	--Commander:Load()
	MenuHelper:LoadFromJsonFile(Commander._path .. "menu/options.txt", Commander, Commander._data)
end)


--make chat available in single player lobbies
function MenuManager:toggle_chatinput()
	if Application:editor() or SystemInfo:platform() ~= Idstring("WIN32") or self:active_menu() or not managers.network:session() then
		return
	end
	if managers.hud then
		managers.hud:toggle_chatinput()
		return true
	end
end
